Protocol Numbers for SCHC
Internet-Draft draft-ietf-schc-protocol-numbers-00
Robert Moskowitz, Ed.
HTT Consulting
Oak Park
MI
48237
USA
rgm@labs.htt-consult.com
Stuart W. Card
AX Enterprize, LLC
4947 Commercial Drive
Yorkville
NY
13495
USA
stu.card@axenterprize.com
Adam Wiethuechter
AX Enterprize, LLC
4947 Commercial Drive
Yorkville
NY
13495
USA
adam.wiethuechter@axenterprize.com
Pascal Thubert
Roquefort-les-Pins
06330
France
pascal.thubert@gmail.com
2024
Internet
INTAREA
RFC
Request for Comments
I-D
Internet-Draft
SCHC
This document requests an Internet Protocol Number, an Ethertype, and UDP port assignment for SCHC. The Internet Protocol Number request is so that SCHC can be used for IP independent SCHC of other transports such as UDP and ESP. The Ethertype is to support generic use of native SCHC over any IEEE 802 technology for IP and non-IP protocols. The UDP port request is to support End-to-End SCHC through potentially blocking firewalls.
Introduction
The Static Context Header Compression (SCHC) Architecture originally envisioned SCHC used at the Network layer to enable IPv6 over selected Low-Power Wide Area Networking (LPWAN) radio technologies, encompassing IP and Transport, by the network provider. Then SCHC would be used by the application; this would include any security envelope.
This approach brakes down when dealing with Diet ESP [I-D.ietf-ipsecme-diet-esp]. When Next Header is ESP, it is challenging for the ESP process to determine if an incoming ESP payload is regular ESP [RFC4303] or a diet ESP payload. Careful allocation of the incoming SPI [I-D.ietf-ipsecme-ikev2-diet-esp-extension] can mitigate this and have an implicit SCHC header, but it is not sound protocol design. If the Next Header in the IP header were SCHC, not ESP, a clear segregation of incoming traffic is directly supportable.
Additionally, SCHC can then be the Next Header within the ESP header with 'regular' SCHC rules for processing this content. This approach will greatly simplify [I-D.ietf-ipsecme-diet-esp].
DTLS 1.3 [RFC9147] adds further complications. DTLS 1.3 headers themselves are typically already very compressed and SCHC would not provide much value. But the UDP header in front of DTLS would benefit of a separate compression from the IP Header compression. Where it is possible with ESP's SPI to mitigate inbound packet processing challenges implicit SCHC would generate, DTLS header does not safely even provide this and a SCHC IP number is necessary to separate traffic.
New IETF work has started with the SCHC WH that is chartered to:
provide specifications for the application of SCHC over underlying layers, where underlying layers include but are not limited to UDP tunnels, IP, PPP, and Ethernet, as well as the use of SCHC by upper-layer protocols.
To achieve its charter, the SCHC working group needs the allocations that are requested in this document.
These issues carry over to IP Header compression if SCHC were available as an Ethertype (for 802 networking) and if SCHC were available as a TCP/UDP port number (for firewall traversal challenges). At each layer, SCHC solves a problem that protocol designers, using constrained networks, currently have to design around.
Basic use case for SCHC as an Internet Protocol Number
A mobile node, or network, may use different links over a period of time. In some cases the node has the multiple interfaces and, in theory, could tune the compression to each interface. In other cases, it is the whole network that is mobile and individual nodes have no "knowledge" of which link with what characteristics is actively handling the traffic. In either case, the node administrator is aware that some links are constrained and use of SCHC compression is highly recommended.
One example is an UA that uses different links over the duration of an operation (i.e. flight).
- Operation starts using Veriport's WiFi service.
- On gaining altitude, UA transitions to a Cellular service.
- On gaining more altitude, UA transitions to a constrained 700MHz UHF service.
- On approach to destination vertiport, link transition is reversed.
The UA could use SCHC compression only on the UHF link, but this may complicate the implementation.
A more complex example is an Unmanned Cargo Aircraft that has multiple avionics systems, all Ethernet connected to an onboard router that has the multiple interfaces. Here the nodes each manage their own secure path to their ground-based server, but have no knowledge of which link is in use to intelligently use compression.
Basic use case for SCHC as an Ethertype
In the case of a classical LPWAN link such as LoRa [RFC9011], the use of SCHC to compress the transported protocol, as well as the SCHC session (called instance) to use, are implicit. The MAC-Layer endpoints are preconfigured so there can be only one session, and there can be only SCHC. When extended to Ethernet and more powerful endpoint, this model is way too restrictive, and it is necessary to signal both the use of SCHC and the SCHC session to be used. While the SCHC WG is charterd to produce the latter, the Ethertype defined in this document will be used to signal SCHC as the upper* layer protocol.
As an example that will leverage this, Aircraft-to-anything (A2X) [I-D.moskowitz-drip-a2x-adhoc-session] and Aircraft-to-Ground [I-D.moskowitz-drip-efficient-a2g-comm] protocols are specific cases that can benefit from SCHC as an Ethertype. These can use IEEE 802 wireless technology and lessen spectrum contention in high traffic or long-range situations by minimizing the datagram size via SCHC.
In the above uses, SCHC compresses the IPv6 header completely (all 40 bytes), leaving only destination address (32 bytes, source address calcuated from content), or only 8 bytes (needs both addresses) at the cost of the 1-byte SCHC RuleID. The 2-byte payload length may be needed in some cases (as in Section 4).
Since the whole point of SCHC is to reduce payload size, SCHC directly over an 802 technology cannot be addressed via the Ethernet Protocol Assignment under the IANA OUI. A distinct Ethertype is needed by SCHC to actually reduce payload overhead.
Basic use case for SCHC as a UDP port number
TBD
Terms and Definitions
Requirements Terminology
The key words "MUST", "MUST NOT", "REQUIRED", "SHALL", "SHALL NOT", "SHOULD", "SHOULD NOT", "RECOMMENDED", "NOT RECOMMENDED", "MAY", and "OPTIONAL" in this document are to be interpreted as described in BCP 14 [RFC2119] [RFC8174] when, and only when, they appear in all capitals, as shown here.
Internet Protocol Number for SCHC
SCHC as the IP payload SHOULD be indicated in the IPv4 "Protocol" field or the IPv6 "Next Header" field with a value of TBD1 (recommended: 145) as shown below:
Internet Protocol Numbers
Decimal | Keyword | Protocol | IPv6 Extension Header | Reference
TBD1 (145) | SCHC | Static Context Header Compression | | This RFC
The SCHC compressed header with payload is shown below. The size of the SCHC RuleID is variable as described in [RFC8724]. An implementation should have a table of source IP address and RuleID size. The addresses should be represented in prefix format to allow for groups of addresses having the same RuleID size.
SCHC Packet

    |------- Compressed Header -------|
    +---------------------------------+--------------------+
    |  RuleID  |  Compression Residue |      Payload       |
    +---------------------------------+--------------------+

The RuleID may be statically configured per [RFC8724], or may be negotiated within a protocol as in IKE [I-D.ietf-ipsecme-ikev2-diet-esp-extension].
Ethertype for SCHC
The use of SCHC as an Ethertype is similar to that as in Section 3, above. Immediately after the SCHC Ethertype is the RuleID as in Figure 1. If the rules for the RuleID does not provide the datagram length, the datagram length MUST be explicit in the Compression Residue, as the 802 header may not provide the needed length information to properly process the datagram.
UDP Port Number for SCHC
TBD
IANA Considerations
IANA Internet Protocol Number Registry Update
This document requests IANA to make the following change to the "Assigned Internet Protocol Numbers" [IANA-IPN] registry:
Internet Protocol Number:
This document defines the new Internet Protocol Number value TBD1 (suggested: 145) (Section 3) in the "Assigned Internet Protocol Numbers" registry.
Decimal | Keyword | Protocol | IPv6 Extension Header | Reference
TBD1 (145) | SCHC | Static Context Header Compression | | This RFC
IANA Ethertype Request
IANA is requested using the process in Section 5.5 of [I-D.ietf-intarea-rfc7042bis], to request the Ethertype for SCHC.
IANA SCHC Ethertype Registry
A registry of SCHC RuleIDs for SCHC as an Ethertype may be needed. More discussion is needed to resolve this. For example, split a 1-byte RuleID in half. The top half of 1-14 assigned to different domains of use, like for aviation. A value of 15 designates that a 2-byte RuleID is used.
Security Considerations
TBD
References

Normative References

Informative References
[IANA-IPN]

Assigned Internet Protocol Numbers
IANA
[I-D.ietf-ipsecme-diet-esp]
[RFC4303]
[I-D.ietf-ipsecme-ikev2-diet-esp-extension]
[RFC9147]
[RFC9011]
[I-D.moskowitz-drip-a2x-adhoc-session]
[I-D.moskowitz-drip-efficient-a2g-comm]
[RFC2119]
[RFC8174]
[RFC8724]
[I-D.ietf-intarea-rfc7042bis]
Acknowledgments
Discussions with Pascal Thubert, lpwan co-chair, helped develop this approach of using SCHC E2E below the current Transport Layers.